// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ShortcutContext, ShortcutManager, ShortcutPhase};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlShortcutController")]
    pub struct ShortcutController(Object<ffi::DzlShortcutController, ffi::DzlShortcutControllerClass>);

    match fn {
        type_ => || ffi::dzl_shortcut_controller_get_type(),
    }
}

impl ShortcutController {
    #[doc(alias = "dzl_shortcut_controller_new")]
    pub fn new(widget: &impl IsA<gtk::Widget>) -> ShortcutController {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_full(ffi::dzl_shortcut_controller_new(
                widget.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_shortcut_controller_add_command_action")]
    pub fn add_command_action(
        &self,
        command_id: &str,
        default_accel: &str,
        phase: ShortcutPhase,
        action: &str,
    ) {
        unsafe {
            ffi::dzl_shortcut_controller_add_command_action(
                self.to_glib_none().0,
                command_id.to_glib_none().0,
                default_accel.to_glib_none().0,
                phase.into_glib(),
                action.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_shortcut_controller_add_command_callback")]
    pub fn add_command_callback<P: Fn(&gtk::Widget) + 'static>(
        &self,
        command_id: &str,
        default_accel: &str,
        phase: ShortcutPhase,
        callback: P,
    ) {
        let callback_data: Box_<P> = Box_::new(callback);
        unsafe extern "C" fn callback_func<P: Fn(&gtk::Widget) + 'static>(
            widget: *mut gtk::ffi::GtkWidget,
            data: glib::ffi::gpointer,
        ) {
            let widget = from_glib_borrow(widget);
            let callback: &P = &*(data as *mut _);
            (*callback)(&widget)
        }
        let callback = Some(callback_func::<P> as _);
        unsafe extern "C" fn callback_data_destroy_func<P: Fn(&gtk::Widget) + 'static>(
            data: glib::ffi::gpointer,
        ) {
            let _callback: Box_<P> = Box_::from_raw(data as *mut _);
        }
        let destroy_call6 = Some(callback_data_destroy_func::<P> as _);
        let super_callback0: Box_<P> = callback_data;
        unsafe {
            ffi::dzl_shortcut_controller_add_command_callback(
                self.to_glib_none().0,
                command_id.to_glib_none().0,
                default_accel.to_glib_none().0,
                phase.into_glib(),
                callback,
                Box_::into_raw(super_callback0) as *mut _,
                destroy_call6,
            );
        }
    }

    //#[doc(alias = "dzl_shortcut_controller_add_command_signal")]
    //pub fn add_command_signal(&self, command_id: &str, default_accel: &str, phase: ShortcutPhase, signal_name: &str, n_args: u32, : /*Unknown conversion*//*Unimplemented*/Basic: VarArgs) {
    //    unsafe { TODO: call ffi:dzl_shortcut_controller_add_command_signal() }
    //}

    #[doc(alias = "dzl_shortcut_controller_execute_command")]
    pub fn execute_command(&self, command: &str) -> bool {
        unsafe {
            from_glib(ffi::dzl_shortcut_controller_execute_command(
                self.to_glib_none().0,
                command.to_glib_none().0,
            ))
        }
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_shortcut_controller_get_context")]
    #[doc(alias = "get_context")]
    pub fn context(&self) -> Option<ShortcutContext> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_controller_get_context(
                self.to_glib_none().0,
            ))
        }
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_shortcut_controller_get_context_for_phase")]
    #[doc(alias = "get_context_for_phase")]
    pub fn context_for_phase(&self, phase: ShortcutPhase) -> Option<ShortcutContext> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_controller_get_context_for_phase(
                self.to_glib_none().0,
                phase.into_glib(),
            ))
        }
    }

    //#[doc(alias = "dzl_shortcut_controller_get_current_chord")]
    //#[doc(alias = "get_current_chord")]
    //pub fn current_chord(&self) -> /*Ignored*/Option<ShortcutChord> {
    //    unsafe { TODO: call ffi:dzl_shortcut_controller_get_current_chord() }
    //}

    #[doc(alias = "dzl_shortcut_controller_get_manager")]
    #[doc(alias = "get_manager")]
    pub fn manager(&self) -> Option<ShortcutManager> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_controller_get_manager(
                self.to_glib_none().0,
            ))
        }
    }

    #[cfg(feature = "v3_34")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_34")))]
    #[doc(alias = "dzl_shortcut_controller_get_widget")]
    #[doc(alias = "get_widget")]
    pub fn widget(&self) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_shortcut_controller_get_widget(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_shortcut_controller_remove_accel")]
    pub fn remove_accel(&self, accel: &str, phase: ShortcutPhase) {
        unsafe {
            ffi::dzl_shortcut_controller_remove_accel(
                self.to_glib_none().0,
                accel.to_glib_none().0,
                phase.into_glib(),
            );
        }
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_shortcut_controller_set_context_by_name")]
    pub fn set_context_by_name(&self, name: Option<&str>) {
        unsafe {
            ffi::dzl_shortcut_controller_set_context_by_name(
                self.to_glib_none().0,
                name.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_shortcut_controller_set_manager")]
    pub fn set_manager(&self, manager: Option<&impl IsA<ShortcutManager>>) {
        unsafe {
            ffi::dzl_shortcut_controller_set_manager(
                self.to_glib_none().0,
                manager.map(|p| p.as_ref()).to_glib_none().0,
            );
        }
    }

    pub fn get_property_context(&self) -> Option<ShortcutContext> {
        ObjectExt::property(self, "context")
    }

    pub fn get_property_widget(&self) -> Option<gtk::Widget> {
        ObjectExt::property(self, "widget")
    }

    #[doc(alias = "dzl_shortcut_controller_find")]
    pub fn find(widget: &impl IsA<gtk::Widget>) -> Option<ShortcutController> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_none(ffi::dzl_shortcut_controller_find(
                widget.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_shortcut_controller_try_find")]
    pub fn try_find(widget: &impl IsA<gtk::Widget>) -> Option<ShortcutController> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_none(ffi::dzl_shortcut_controller_try_find(
                widget.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "reset")]
    pub fn connect_reset<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn reset_trampoline<F: Fn(&ShortcutController) + 'static>(
            this: *mut ffi::DzlShortcutController,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"reset\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    reset_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    pub fn emit_reset(&self) {
        self.emit_by_name::<()>("reset", &[]);
    }

    #[doc(alias = "set-context-named")]
    pub fn connect_set_context_named<F: Fn(&Self, &str) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn set_context_named_trampoline<
            F: Fn(&ShortcutController, &str) + 'static,
        >(
            this: *mut ffi::DzlShortcutController,
            name: *mut libc::c_char,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                &from_glib_borrow(this),
                &glib::GString::from_glib_borrow(name),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"set-context-named\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    set_context_named_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    pub fn emit_set_context_named(&self, name: &str) {
        self.emit_by_name::<()>("set-context-named", &[&name]);
    }

    #[doc(alias = "context")]
    pub fn connect_context_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_context_trampoline<F: Fn(&ShortcutController) + 'static>(
            this: *mut ffi::DzlShortcutController,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::context\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_context_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "current-chord")]
    pub fn connect_current_chord_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_current_chord_trampoline<
            F: Fn(&ShortcutController) + 'static,
        >(
            this: *mut ffi::DzlShortcutController,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::current-chord\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_current_chord_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "manager")]
    pub fn connect_manager_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_manager_trampoline<F: Fn(&ShortcutController) + 'static>(
            this: *mut ffi::DzlShortcutController,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::manager\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_manager_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for ShortcutController {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ShortcutController")
    }
}
